package org.artifactory.storage.db.locks;

import org.testng.annotations.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;


public class LockInfoTest {

    @Test
    public void lockInfoConstructorCategoryAndOwnerMoreThan75ExpectException() {
        try {
            new LockInfo("1234567890123456789012345678901234567890123456789012345678901234567890", null,
                    "12345678901234567890123456789012345678901234567890123456789012345678901234567890",
                    0, null, 0);
        } catch (IllegalArgumentException e) {
            assertEquals(
                    "Category 1234567890123456789012345678901234567890123456789012345678901234567890 " +
                            "exceeds maximum allowed length of 64.", e.getMessage());
        }
    }

    @Test
    public void lockInfoConstructorOwnerMoreThan75ExpectException() {
        try {
            new LockInfo("12345", null,
                    "1234567890123456789012345678901234567890123456789012345678901234567890",
                    0, null, 0);
        } catch (IllegalArgumentException e) {
            assertEquals("Owner 1234567890123456789012345678901234567890123456789012345678901234567890" +
                    " exceeds maximum allowed length of 64.", e.getMessage());
        }
    }

    @Test
    public void lockInfoConstructorOwnerAndCategoryNullOrCorrectExpectNoException() {
        try {
            new LockInfo(null, null, null, 0, null, 0);
            new LockInfo("null", null, "null", 0, null, 0);
            new LockInfo(null, null, "null", 0, null, 0);
        } catch (IllegalArgumentException e) {
            fail();
        }
    }
}
